# -*- coding: utf-8 -*-
"""Projekt.ipynb

Automatically generated by Colaboratory.

Original file is located at
    https://colab.research.google.com/drive/1hvuZKYe8FFE7icJMmg2BFN4CfoPs_-x-
"""

!pip install pandas --upgrade
!pip install numpy --upgrade
!pip install wordcloud --upgrade
!pip install Pillow --upgrade
!pip install seaborn --upgrade
!pip install matplotlib --upgrade

from collections import Counter
from google.colab import drive
import pandas as pd
import numpy as np
import matplotlib as mpl
from matplotlib import pyplot as plt
import seaborn as sns
import warnings
from collections import Counter
import datetime
from wordcloud import WordCloud, STOPWORDS, ImageColorGenerator
from PIL import Image
import json
drive.mount('/content/drive')

# data: https://www.kaggle.com/datasnaek/youtube-new#CA_category_id.json
data_US = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/USvideos.csv")
data_CA = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/CAvideos.csv")
data_DE = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/DEvideos.csv")
data_GB = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/GBvideos.csv")
data_FR = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/FRvideos.csv")
data_IN = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/INvideos.csv")
data_MX = pd.read_csv("/content/drive/Shared drives/Vizualizace/youtube/MXvideos.csv",encoding='"ISO-8859-1"')

key_word = {1:"Film & Animation",2:"Autos & Vehicles",10:"Music",15:"Pets & Animals",17:"Sports",29:"Nonprofits & Activism",18:"Short Movies",19:"Travel & Events",20:"Gaming",21:"Videoblogging",22:"People & Blogs",23:"Comedy",24:"Entertainment",25:"News & Politics",26:"Howto & Style",27:"Education",28:"Science & Technology",30:"Movies",31:"Anime/Animation",32:"Action/Adventure",33:"Classics",34:"Comedy",35:"Documentary",36:"Drama",37:"Family",38:"Foreign",39:"Horror",40:"Sci-Fi/Fantasy",41:"Thriller",42:"Shorts",43:"Shows",44:"Trailers"}

stopwords = set(STOPWORDS)
colors = ["#268bd2", "#0052CC", "#FF5722", "#b58900", "#003f5c"]
countries = ['USA','Canada','Germany','United Kingdom', 'France','India','Mexico']
flags = ['/content/drive/Shared drives/Vizualizace/flags/US.png','/content/drive/Shared drives/Vizualizace/flags/CA.png','/content/drive/Shared drives/Vizualizace/flags/DE.png','/content/drive/Shared drives/Vizualizace/flags/UK.png','/content/drive/Shared drives/Vizualizace/flags/FR.png', '/content/drive/Shared drives/Vizualizace/flags/IN.png', '/content/drive/Shared drives/Vizualizace/flags/MX.png']

clean_list = []
for a in [data_US,data_CA,data_DE,data_GB,data_FR,data_IN,data_MX]:
  print(a)
  a["description"] = a["description"].fillna(value="") # nahrazeni N/A NULL popisku za prazdny string
  clean_list.append(a)

# nejoblibenější ketegorie
i = 0
for a in clean_list:
  cdf = a.groupby("category_id").size().reset_index(name="video_count") \
    .sort_values("video_count", ascending=False).head(20) # omezeno na top 20
  cdf["category_id"] = cdf["category_id"].apply(lambda x: key_word[x])
  fig, ax = plt.subplots(figsize=(8,8))
  _ = sns.barplot(x="video_count", y="category_id", data=cdf,
                palette=sns.cubehelix_palette(rot=-.4,n_colors=20, reverse=True), ax=ax).set_title(countries[i])
  _ = ax.set(xlabel="No. of videos", ylabel="Kategorie")
  i+=1

# nejčastější délka názvu videa v kategorii trending 
i = 0
for a in clean_list:
  a["title_length"] = a["title"].apply(lambda x: len(x))
  fig, ax = plt.subplots()
  _ = sns.distplot(a["title_length"], kde=False, rug=False, 
                 color=colors[4], hist_kws={'alpha': 1}, ax=ax).set_title(countries[i])
  _ = ax.set(xlabel="Title Length", ylabel="No. of videos", xticks=range(0, 110, 10))
  i+=1

# častá slova v názvech videí
for index, a in enumerate(clean_list):
  title_words = list(a["title"].apply(lambda x: x.split()))
  title_words = [x for y in title_words for x in y]
  mask = np.array(Image.open(flags[index]).convert("RGBA"))
  wc = WordCloud(stopwords=stopwords, background_color="white", mode="RGBA", max_words=1000, mask=mask).generate(" ".join(title_words))
  image_colors = ImageColorGenerator(mask)
  plt.figure(figsize=[8,8])
  plt.imshow(wc.recolor(color_func=image_colors), interpolation="bilinear")
  plt.axis("off")

# trending kanaly
i = 0
for a in clean_list:
  cdf = a.groupby("channel_title").size().reset_index(name="video_count") \
    .sort_values("video_count", ascending=False).head(20)
  fig, ax = plt.subplots(figsize=(8,8))
  _ = sns.barplot(x="video_count", y="channel_title", data=cdf,
                palette=sns.cubehelix_palette(rot=-.4,n_colors=20, reverse=True), ax=ax).set_title(countries[i])
  _ = ax.set(xlabel="No. of videos", ylabel="Channel")
  i+=1

christmas = '17.24.12'
i=0
for index, a in enumerate(clean_list):
  christmas_videos = a.trending_date == christmas
  christmas_videos = a[christmas_videos] # omezení na vánoce
  title_words = list(christmas_videos["title"].apply(lambda x: x.split()))
  title_words = [x for y in title_words for x in y]
  mask = np.array(Image.open('/content/drive/Shared drives/Vizualizace/christmas/minimal.jpg').convert("RGBA")) # maska
  wc = WordCloud(stopwords=stopwords, background_color="white", mode="RGBA", max_words=1000, mask=mask).generate(" ".join(title_words))
  image_colors = ImageColorGenerator(mask)
  plt.figure(figsize=[10,10])
  plt.imshow(wc.recolor(color_func=image_colors), interpolation="bilinear")
  plt.axis("off")

  # kategorie na vanoce
  cdf = christmas_videos.groupby("category_id").size().reset_index(name="video_count") \
    .sort_values("video_count", ascending=False).head(20)
  cdf["category_id"] = cdf["category_id"].apply(lambda x: key_word[x])
  fig, ax = plt.subplots(figsize=(8,8))
  _ = sns.barplot(x="video_count", y="category_id", data=cdf,
                palette=sns.cubehelix_palette(rot=-.4,n_colors=20, reverse=True), ax=ax).set_title(countries[i])
  _ = ax.set(xlabel="No. of videos", ylabel="Kategorie")
  i+=1

social = ["facebook","instagram","twitter","reddit","tumblr","pinterest"]
n_soc = 0
soc = 0
# hledani vyskytu socialnich siti v popisku
for a in clean_list:
  for d in a["description"]:
    if social[0] in d.lower() or social[1] in d.lower() or social[2] in d.lower():
      soc+=1
    else:
      n_soc+=1
print(soc)
print(n_soc)
coun = soc + n_soc

df = pd.DataFrame({'Počty videí': [soc,n_soc]},
                  index=['obsahuje odkaz','neobsahuje odkaz'])
plot = df.plot.pie(y='Počty videí', figsize=(6, 6), labels=None,autopct='%1.0f%%')


# popularni klicova slova
i = 0
key_words = []
for a in clean_list[0:-3]:
  temp = a["tags"].apply(lambda x: x.replace('"','').split('|'))
  key_words.append(temp)

for country in key_words:
  flat_list = []
  for words in country:
    for word in words:
      flat_list.append(word)
key_dict = dict(Counter(flat_list).most_common(20))
del key_dict['[none]']
key_dict = sorted(key_dict.items(), key=lambda x: x[1],reverse=True)

tags = list(zip(*key_dict))[0]
count_tag = list(zip(*key_dict))[1]
x_pos = np.arange(len(tags)) 

slope, intercept = np.polyfit(x_pos, count_tag, 1)
plt.subplots(figsize=(20,8))

plt.plot()
plt.bar(x_pos, count_tag,align='center')
plt.xticks(x_pos, tags) 
plt.ylabel('Popular tags')
plt.show()

